#!/bin/sh
set -e

# Source env file
SCRIPT=`readlink -f $0`
SCRIPTDIR=`dirname $SCRIPT`
SCRIPTNAME=`basename $SCRIPT`
ROOTDIR="$SCRIPTDIR/../.."
. $SCRIPTDIR/env.sh


cd $ROOTDIR


# Build war
docker run -u root -w "/var/lib/tomcat9/build" --volume "${ROOTDIR}:/var/lib/tomcat9/build" docker.alkante.com/alk-tomcat:9 bash -c "./mvnw install:install-file -DgroupId=org.geonetwork-opensource -DartifactId=geonetwork -Dversion=4.4.1-0 -Dpackaging=war -Dfile=./source/geonetwork-4.4.1-0.war && ./mvnw clean package"

docker run -u root -w "/var/lib/tomcat9/build" --volume "${ROOTDIR}:/var/lib/tomcat9/build" docker.alkante.com/alk-tomcat:9 chown -R $(id -u):$(id -g) .
