UPDATE Settings SET value='4.4.0' WHERE name='system/platform/version';
UPDATE Settings SET value='0' WHERE name='system/platform/subVersion';

INSERT INTO Settings (name, value, datatype, position, internal) SELECT distinct 'metadata/batchediting/accesslevel', 'Editor', 0, 12020, 'n' from settings WHERE NOT EXISTS (SELECT name FROM Settings WHERE name = 'metadata/batchediting/accesslevel');

UPDATE Settings SET editable='y' WHERE editable is null;
ALTER TABLE public.settings ALTER COLUMN editable TYPE bpchar(1) USING editable::bpchar(1);
ALTER TABLE public.settings ALTER COLUMN editable SET DEFAULT 'y'::bpchar;
ALTER TABLE public.settings ALTER COLUMN editable set not null;

update public.settings_ui set configuration = '
{
  "langDetector": {
    "fromHtmlTag": false,
    "regexp": "^(?:/.+)?/.+/([a-z]{2,3})/.+",
    "default": "eng"
  },
  "nodeDetector": {
    "regexp": "^(?:/.+)?/(.+)/[a-z]{2,3}/.+",
    "default": "srv"
  },
  "serviceDetector": {
    "regexp": "^(?:/.+)?/.+/[a-z]{2,3}/(.+)",
    "default": "catalog.search"
  },
  "baseURLDetector": {
    "regexp": "^((?:/.+)?)+/.+/[a-z]{2,3}/.+",
    "default": "/geonetwork"
  },
  "mods": {
    "global": {
      "humanizeDates": true,
      "dateFormat": "DD-MM-YYYYHH:mm",
      "timezone": "Browser"
    },
    "footer": {
      "enabled": true,
      "showSocialBarInFooter": true
    },
    "header": {
      "enabled": true,
      "isLogoInHeader": false,
      "logoInHeaderPosition": "left",
      "fluidHeaderLayout": true,
      "showGNName": true,
      "isHeaderFixed": false,
      "isMenubarAccessible": true
    },
    "cookieWarning": {
      "enabled": true,
      "cookieWarningMoreInfoLink": "",
      "cookieWarningRejectLink": ""
    },
    "home": {
      "enabled": true,
      "appUrl": "../../srv/{{lang}}/catalog.search#/home",
      "showSocialBarInFooter": true,
      "fluidLayout": true,
      "showMosaic": false,
      "facetConfig": {
        "cl_topic.key": {
          "terms": {
            "field": "cl_topic.key",
            "size": 20
          },
          "meta": {
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-2x pull-left gn-icon-"
            }
          }
        },
        "resourceType": {
          "terms": {
            "field": "resourceType",
            "size": 10
          },
          "meta": {
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-2x pull-left gn-icon-"
            }
          }
        }
      }
    },
    "search": {
      "enabled": true,
      "facetConfig": {
        "th_prodige_tree.default": {
          "terms": {
            "field": "th_prodige_tree.default",
            "size": 500,
            "order": {
              "_key": "asc"
            }
          },
          "meta": {
            "translateOnLoad": true,
            "treeKeySeparator": "^"
          }
        },
        "resourceType": {
          "terms": {
            "field": "resourceType"
          },
          "meta": {
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-fw gn-icon-"
            }
          }
        },
        "sourceCatalogue": {
          "terms": {
            "field": "sourceCatalogue",
            "size": 15
          }
        },
        "cl_spatialRepresentationType.key": {
          "terms": {
            "field": "cl_spatialRepresentationType.key",
            "size": 10
          }
        },
        "format": {
          "terms": {
            "field": "format"
          },
          "meta": {
            "collapsed": true
          }
        },
        "availableInServices": {
          "filters": {
            "filters": {
              "availableInViewService": {
                "query_string": {
                  "query": "+linkProtocol:/OGC:WMS.*/"
                }
              },
              "availableInDownloadService": {
                "query_string": {
                  "query": "+linkProtocol:/OGC:WFS.*/"
                }
              }
            }
          },
          "meta": {
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-fw ",
              "map": {
                "availableInViewService": "fa-globe",
                "availableInDownloadService": "fa-download"
              }
            }
          }
        },
        "th_gemet_tree.default": {
          "terms": {
            "field": "th_gemet_tree.default",
            "size": 100,
            "order": {
              "_key": "asc"
            },
            "include": "[^^]+^?[^^]+"
          }
        },
        "tag": {
          "terms": {
            "field": "tag.${aggLang}",
            "include": ".*",
            "size": 10
          },
          "meta": {
            "caseInsensitiveInclude": true
          }
        },
        "th_regions_tree.default": {
          "terms": {
            "field": "th_regions_tree.default",
            "size": 100,
            "order": {
              "_key": "asc"
            }
          }
        },
        "resolutionScaleDenominator": {
          "histogram": {
            "field": "resolutionScaleDenominator",
            "interval": 10000,
            "keyed": true,
            "min_doc_count": 1
          },
          "meta": {
            "collapsed": true
          }
        },
        "creationYearForResource": {
          "histogram": {
            "field": "creationYearForResource",
            "interval": 5,
            "keyed": true,
            "min_doc_count": 1
          },
          "meta": {
            "collapsed": true
          }
        },
        "OrgForResource": {
          "terms": {
            "field": "OrgForResourceObject.${aggLang}",
            "include": ".*",
            "size": 20
          },
          "meta": {
            "caseInsensitiveInclude": true
          }
        },
        "cl_maintenanceAndUpdateFrequency.key": {
          "terms": {
            "field": "cl_maintenanceAndUpdateFrequency.key",
            "size": 10
          },
          "meta": {
            "collapsed": true
          }
        }
      }
    },
    "map": {
      "enabled": false
    },
    "geocoder": {
      "enabled": true,
      "appUrl": "https://secure.geonames.org/searchJSON"
    },
    "recordview": {
      "isSocialbarEnabled": true,
      "showStatusWatermarkFor": "historicalArchive,obsolete,superseded",
      "showStatusTopBarFor": "",
      "enabled": true
    },
    "editor": {
      "enabled": true,
      "appUrl": "../../srv/{{lang}}/catalog.edit",
      "isUserRecordsOnly": false,
      "minUserProfileToCreateTemplate": "",
      "isFilterTagsDisplayed": false,
      "fluidEditorLayout": true,
      "createPageTpl": "../../catalog/templates/editor/new-metadata-horizontal.html",
      "editorIndentType": "",
      "allowRemoteRecordLink": true,
      "facetConfig": {
        "th_prodige_tree.default": {
          "terms": {
            "field": "th_prodige_tree.default",
            "size": 500,
            "order": {
              "_key": "asc"
            }
          },
          "meta": {
            "translateOnLoad": true,
            "treeKeySeparator": "^"
          }
        },
        "resourceType": {
          "terms": {
            "field": "resourceType"
          },
          "meta": {
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-fw gn-icon-"
            }
          }
        },
        "cl_status.key": {
          "terms": {
            "field": "cl_status.key",
            "size": 15
          }
        },
        "valid": {
          "terms": {
            "field": "valid",
            "size": 10
          }
        },
        "sourceCatalogue": {
          "terms": {
            "field": "sourceCatalogue",
            "size": 100,
            "include": ".*"
          },
          "meta": {
            "orderByTranslation": true,
            "filterByTranslation": true,
            "displayFilter": true,
            "collapsed": true
          }
        },
        "groupOwner": {
          "terms": {
            "field": "groupOwner",
            "size": 200,
            "include": ".*"
          },
          "meta": {
            "orderByTranslation": true,
            "filterByTranslation": true,
            "displayFilter": true,
            "collapsed": true
          }
        },
        "recordOwner": {
          "terms": {
            "field": "recordOwner",
            "size": 5,
            "include": ".*"
          },
          "meta": {
            "collapsed": true
          }
        },
        "isPublishedToAll": {
          "terms": {
            "field": "isPublishedToAll",
            "size": 2
          },
          "meta": {
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-fw ",
              "map": {
                "false": "fa-lock",
                "true": "fa-unlock"
              }
            }
          }
        },
        "groupPublishedId": {
          "terms": {
            "field": "groupPublishedId",
            "size": 200,
            "include": ".*"
          },
          "meta": {
            "orderByTranslation": true,
            "filterByTranslation": true,
            "displayFilter": true,
            "collapsed": true
          }
        },
        "documentStandard": {
          "terms": {
            "field": "documentStandard",
            "size": 10
          },
          "meta": {
            "collapsed": true
          }
        },
        "isHarvested": {
          "terms": {
            "field": "isHarvested",
            "size": 2
          },
          "meta": {
            "collapsed": true,
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-fw ",
              "map": {
                "false": "fa-folder",
                "true": "fa-cloud"
              }
            }
          }
        },
        "isTemplate": {
          "terms": {
            "field": "isTemplate",
            "size": 5
          },
          "meta": {
            "collapsed": true,
            "decorator": {
              "type": "icon",
              "prefix": "fa fa-fw ",
              "map": {
                "n": "fa-file-text",
                "y": "fa-file"
              }
            }
          }
        }
      }
    },
    "admin": {
      "enabled": true,
      "appUrl": "../../srv/{{lang}}/admin.console",
      "facetConfig": {}
    },
    "authentication": {
      "enabled": true,
      "signinUrl": "https://cas.prodige.internal",
      "signoutUrl": "../../signout"
    },
    "page": {
      "enabled": false,
      "appUrl": "../../{{node}}/{{lang}}/catalog.search#/page"
    },
    "signin": {
      "enabled": true,
      "appUrl": "../../signin"
    },
    "signout": {
      "appUrl": "../../signout"
    }
  }
}' where id='srv';


-- since gn has a bug on delete add constraint on delete cascade on metadatastatus
ALTER TABLE IF EXISTS public.metadatastatus DROP CONSTRAINT IF EXISTS metadatastatus_metadataid_fkey;
  
ALTER TABLE IF EXISTS public.metadatastatus
    ADD CONSTRAINT metadatastatus_metadataid_fkey FOREIGN KEY (metadataid) REFERENCES public.metadata (id) ON DELETE CASCADE;